﻿Public Class Main

    Dim ImagemOriginal As Bitmap
    Dim habilitaCamara As Boolean = False

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Try

            If WindowState = 2 Then WindowState = 0

            CarregaListaDispositivo()

            If My.Computer.FileSystem.FileExists(GetSetting("WebCam", "Settings", "CaminhoAviso")) Then
                ofd1.FileName = GetSetting("WebCam", "Settings", "CaminhoAviso")
            End If

            If My.Computer.FileSystem.DirectoryExists(GetSetting("WebCam", "Settings", "CaminhoImagem")) Then
                fbd1.SelectedPath = GetSetting("WebCam", "Settings", "CaminhoImagem")
            End If
        Catch ex As Exception
            Throw ex
        End Try
    End Sub

    Private Sub CarregaListaDispositivo()

        Dim strName As String = Space(100)
        Dim strVer As String = Space(100)
        Dim bReturn As Boolean
        Dim x As Integer = 0
        cboCameras.Items.Clear()
        Do
            bReturn = capGetDriverDescriptionA(x, strName, 100, strVer, 100)
            If bReturn Then cboCameras.Items.Add(strName.Trim)
            x += 1
        Loop Until bReturn = False
        If cboCameras.Items.Count > 0 Then
            cboCameras.SelectedIndex = 0
        Else
            MsgBox("Nenhum dispositivo Encontrado.", 48)
        End If
    End Sub

    Private Sub btnIniciar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnIniciar.Click
        If btnIniciar.Text = "Iniciar" Then
            iDevice = cboCameras.SelectedIndex
            AbrirJanelaVisualizacao()
            cboCameras.Enabled = False
            btnHabilitarSeguranca.Enabled = True
            btnIniciar.Text = "Parar"
        Else
            btnHabilitarSeguranca.Enabled = False
            FecharJanelaVisualizacao()
            cboCameras.Enabled = True
            btnIniciar.Text = "Iniciar"
        End If
    End Sub

    Private Sub AbrirJanelaVisualizacao()
        Try
            Dim iHeight As Integer = picCaptura.Height
            Dim iWidth As Integer = picCaptura.Width
            hHwnd = capCreateCaptureWindowA(iDevice, WS_VISIBLE Or WS_CHILD, 0, 0, 640, 480, picCaptura.Handle.ToInt32, 0)
            If SendMessage(hHwnd, WM_CAP_DRIVER_CONNECT, iDevice, 0) Then
                SendMessage(hHwnd, WM_CAP_SET_SCALE, True, 0)
                SendMessage(hHwnd, WM_CAP_SET_PREVIEWRATE, 66, 0)
                SendMessage(hHwnd, WM_CAP_SET_PREVIEW, True, 0)
                SetWindowPos(hHwnd, HWND_BOTTOM, 0, 0, picCaptura.Width, picCaptura.Height, SWP_NOMOVE Or SWP_NOZORDER)
            Else
                DestroyWindow(hHwnd)
            End If
        Catch ex As Exception
            Throw ex
        End Try
    End Sub

    Private Sub FecharJanelaVisualizacao()
        Try
            SendMessage(hHwnd, WM_CAP_DRIVER_DISCONNECT, iDevice, 0)
            DestroyWindow(hHwnd)
        Catch ex As Exception
            Throw ex
        End Try
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        If btnIniciar.Text = "Parar" Then FecharJanelaVisualizacao()
    End Sub

    Private Function CapturarImagem() As Bitmap
        Dim data As IDataObject
        Dim Imagem As Bitmap = Nothing
        SendMessage(hHwnd, WM_CAP_EDIT_COPY, 0, 0)
        data = Clipboard.GetDataObject()
        If data.GetDataPresent(GetType(System.Drawing.Bitmap)) Then
            Imagem = CType(data.GetData(GetType(System.Drawing.Bitmap)), Image)
        End If
        Return Imagem
    End Function


    Private Sub btnProcurar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnProcurar.Click
        CarregaListaDispositivo()
    End Sub


    Private Sub btnSobre_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSobre.Click
        MsgBox("Captura Câmera " + Chr(13) + "Macoratti .net" + Chr(13) + "http://www.macoratti.net" + Chr(13) + "Email: macoratti@yahoo.com", 64, "Sobre...")
    End Sub

    Private Sub btnHabilitarSeguranca_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHabilitarSeguranca.Click
        If btnHabilitarSeguranca.Text.Contains("Habilitar") Then
            ImagemOriginal = CapturarImagem()
            habilitaCamara = True
            btnHabilitarSeguranca.Text = "Desabilitar Câmera"
        Else
            habilitaCamara = False
            Try
                ImagemOriginal.Dispose()
                ImagemOriginal = Nothing
            Catch
            End Try
            btnHabilitarSeguranca.Text = "Habilitar Câmera"
        End If
    End Sub

    Private Sub btnProcurarSom_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnProcurarSom.Click
        If ofd1.ShowDialog = Windows.Forms.DialogResult.OK Then
            SaveSetting("WebCam", "Settings", "CaminhoAviso", ofd1.FileName)
            Try
                If chkTocarSom.Checked And ofd1.FileName IsNot Nothing Then
                    My.Computer.Audio.Play(ofd1.FileName, AudioPlayMode.BackgroundLoop)
                End If
            Catch
            End Try
        End If
    End Sub

    Private Sub btnProcurarImagem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnProcurarImagem.Click
        If fbd1.ShowDialog = Windows.Forms.DialogResult.OK Then
            Dim ImagemTeste As Bitmap = CapturarImagem()
            SaveSetting("WebCam", "Settings", "CaminhoImagem", fbd1.SelectedPath)
            Try
                If chkPegaImagem.Checked And habilitaCamara Then
                    ImagemTeste.Save(fbd1.SelectedPath + "\" + CStr(Now.Ticks) + ".jpg", Imaging.ImageFormat.Jpeg)
                End If
            Catch
                Throw
            End Try
        End If
    End Sub

End Class
